clear all
clc

CONS = {'C','D','G','J','S','T','Z','b','d','f','g','h','k','L','m','n','p','r','s','t','v','w','y','z'};
VOWS = {'@','A','E','I','O','R','U','W','Y','a','c','e','i','o','u'};
CON = 1;
VOW = 2;
% offest to con vow depending on position
INI = 2;
FIN = 4;

SUBJECTS = {'Alina','Angela','Anton','Bob','Carly','Edward','Evan','Joanna', 'Latisha','Laura','Miguel','Norene','Shauna','Teddy','Tony'};


% get usbject names
d=dir('../*.mat')

for sbj = 1 : length(d)
    mat_name = d(sbj).name
    load(['../' mat_name]);
    SBJS{1,sbj} =  mat_name(6:length(mat_name)-4);
    
    error_cons = zeros(2,length(CONS));
    n_cons = zeros(2,length(CONS));
    error_vows = zeros(2,length(VOWS));
    n_vows = zeros(2,length(VOWS));
    
    for trial = 1 : length(data)
        if strcmp(data(trial).tgt1,'Q')
            data(trial).tgt1 = '@';
        end
        if strcmp(data(trial).tgt2,'Q')
            data(trial).tgt2 = '@';
        end
        if strcmp(data(trial).msk1,'Q')
            data(trial).msk1 = '@';
        end
        if strcmp(data(trial).msk2,'Q')
            data(trial).msk2 = '@';
        end
        
        
        % Was first or second sound changed?
        if ~strcmp(data(trial).tgt1,data(trial).msk1)
            pos = 1; % inital was changed
            % VOW in inital position?
            vow_pos = find(strcmp(data(trial).tgt1,VOWS));
            con_pos = find(strcmp(data(trial).tgt1,CONS));
            if  ~isempty(vow_pos)
                if data(trial).score == 0
                    error_vows(pos,vow_pos) = error_vows(pos,vow_pos) + 1;
                end
                n_vows(pos,vow_pos) = n_vows(pos,vow_pos) + 1;
            elseif ~isempty(con_pos)
                con_pos = find(strcmp(data(trial).tgt1,CONS));
                if data(trial).score == 0
                    error_cons(pos,con_pos) = error_cons(pos,con_pos) + 1;
                end
                n_cons(pos,con_pos) = n_cons(pos,con_pos) + 1;
            else
                disp(['something is fishy with ' data(trial).tgt1 ' in initial position in trial ' num2str(trial)]);
            end
        elseif ~strcmp(data(trial).tgt2,data(trial).msk2)
            pos = 2; % final postion changed
            % VOW in final position?
            vow_pos = find(strcmp(data(trial).tgt2,VOWS));
            con_pos = find(strcmp(data(trial).tgt2,CONS));
            if  ~isempty(vow_pos)
                if data(trial).score == 0
                    error_vows(pos,vow_pos) = error_vows(pos,vow_pos) + 1;
                end
                n_vows(pos,vow_pos) = n_vows(pos,vow_pos) + 1;
            elseif ~isempty(con_pos)
                if data(trial).score == 0
                    error_cons(pos,con_pos) = error_cons(pos,con_pos) + 1;
                end
                n_cons(pos,con_pos) = n_cons(pos,con_pos) + 1;
            else
                disp(['something is fishy with ' data(trial).tgt2 ' in final position in trial ' num2str(trial)]);
            end
        else
            disp(['something is fishy ' num2str(trial)]);
        end
    end
    % Consonants
    xlswrite('xls/number_percent_correct.xls',{'Consonants'},SBJS{1,sbj}, 'A1')
    % overall
    select = [1:2];
    xlswrite('xls/number_percent_correct.xls',{'Overall'},SBJS{1,sbj}, 'B2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'B3:D3')
    xlswrite('xls/number_percent_correct.xls',CONS',SBJS{1,sbj}, 'A4:A27')
    xlswrite('xls/number_percent_correct.xls',{'Total'},SBJS{1,sbj}, 'A28')
    xlswrite('xls/number_percent_correct.xls',[sum(n_cons,1)' (sum(n_cons,1)-sum(error_cons,1))' ((sum(n_cons,1)-sum(error_cons,1))./sum(n_cons,1))'; sum(sum(n_cons,1)) sum((sum(n_cons,1)-sum(error_cons,1))) sum((sum(n_cons,1)-sum(error_cons,1))./sum(n_cons,1))],SBJS{1,sbj}, 'B4:D28')
    % initial
    select = 1;
    xlswrite('xls/number_percent_correct.xls',{'Initial'},SBJS{1,sbj}, 'E2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'E3:G3')
    xlswrite('xls/number_percent_correct.xls',[n_cons(select,:)' (n_cons(select,:)-error_cons(select,:))' ((n_cons(select,:)-error_cons(select,:))./n_cons(select,:))'; sum(n_cons(select,:)) sum((n_cons(select,:)-error_cons(select,:))) sum((n_cons(select,:)-error_cons(select,:)))/sum(n_cons(select,:))],SBJS{1,sbj}, 'H4:J28')
    % final
    select = 2;
    xlswrite('xls/number_percent_correct.xls',{'Final'},SBJS{1,sbj}, 'H2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'H3:J3')
    xlswrite('xls/number_percent_correct.xls',[n_cons(select,:)' (n_cons(select,:)-error_cons(select,:))' ((n_cons(select,:)-error_cons(select,:))./n_cons(select,:))'; sum(n_cons(select,:)) sum((n_cons(select,:)-error_cons(select,:))) sum((n_cons(select,:)-error_cons(select,:)))/sum(n_cons(select,:))],SBJS{1,sbj}, 'E4:G28')
    
    %Vowels
    xlswrite('xls/number_percent_correct.xls',{'Vowels'},SBJS{1,sbj}, 'A30')
    % overall
    select = [1:2];
    xlswrite('xls/number_percent_correct.xls',{'Overall'},SBJS{1,sbj}, 'B31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'B32:D32')
    xlswrite('xls/number_percent_correct.xls',VOWS',SBJS{1,sbj}, 'A33:A47')
    xlswrite('xls/number_percent_correct.xls',{'Total'},SBJS{1,sbj}, 'A48')
    xlswrite('xls/number_percent_correct.xls',[sum(n_vows,1)' (sum(n_vows,1)-sum(error_vows,1))' ((sum(n_vows,1)-sum(error_vows,1))./sum(n_vows,1))'; sum(sum(n_vows,1)) sum((sum(n_vows,1)-sum(error_vows,1))) sum((sum(n_vows,1)-sum(error_vows,1))./sum(n_vows,1))],SBJS{1,sbj}, 'B33:D48')
    % initial
    select = 1;
    xlswrite('xls/number_percent_correct.xls',{'Initial'},SBJS{1,sbj}, 'E31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'E32:G32')
    xlswrite('xls/number_percent_correct.xls',[n_vows(select,:)' (n_vows(select,:)-error_vows(select,:))' ((n_vows(select,:)-error_vows(select,:))./n_vows(select,:))'; sum(n_vows(select,:)) sum((n_vows(select,:)-error_vows(select,:))) sum((n_vows(select,:)-error_vows(select,:)))/sum(n_vows(select,:))],SBJS{1,sbj}, 'E33:G48')
    % final
    select = 2;
    xlswrite('xls/number_percent_correct.xls',{'Final'},SBJS{1,sbj}, 'H31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},SBJS{1,sbj}, 'H32:J32')
    xlswrite('xls/number_percent_correct.xls',[n_vows(select,:)' (n_vows(select,:)-error_vows(select,:))' ((n_vows(select,:)-error_vows(select,:))./n_vows(select,:))'; sum(n_vows(select,:)) sum((n_vows(select,:)-error_vows(select,:))) sum((n_vows(select,:)-error_vows(select,:)))/sum(n_vows(select,:))],SBJS{1,sbj}, 'H33:J48')
end
